## Best Practices

### Do

- Provide descriptive, accurate and concise description for `alt` attribute in order to be accessible to screen readers.

- The `alt` description should also include and consider the context where the image fits in.

- Decorative images should be excluded for assistive tools, thus adding `role="presentation"` or `aria-hidden="true"`.

### Don't

- Don't include "image of", "picture of" etc. in the `alt` attribute since it is redundant.

- Don't repeat the same information that is already on the page on the `alt` attribute.
